package com.burtbeckwith.gae.guestbook.controller

import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Controller
import org.springframework.ui.Model
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestMethod
import org.springframework.web.bind.annotation.RequestParam

import com.burtbeckwith.gae.guestbook.domain.Friend
import com.burtbeckwith.gae.guestbook.service.FriendService

@Controller
class FriendController {

	private final FriendService _friendService

	@Autowired
	FriendController(FriendService friendService) {
		_friendService = friendService
	}

	@RequestMapping(value="/friends/list.action", method=RequestMethod.GET)
	String list(
			@RequestParam(value='lastName', required=false) String lastName,
			@RequestParam(value='firstName', required=false) String firstName,
			Model model) {

		if (!lastName) {
			lastName = 'Rubble'
		}

		if (!firstName) {
			firstName = 'Barney'
		}

		List<Friend> friends = _friendService.getFriendsOf(lastName, firstName)

		model.addAttribute('firstName', firstName)
		model.addAttribute('lastName', lastName)
		model.addAttribute('friends', friends)

		return 'friends'
	}

	@RequestMapping(value='/friends/add.action', method=RequestMethod.POST)
	String addFriend(
			@RequestParam('lastName') String lastName,
			@RequestParam('firstName') String firstName,
			@RequestParam('friendLastName') String friendLastName,
			@RequestParam('friendFirstName') String friendFirstName) {

		_friendService.addFriendTo(lastName, firstName,
				friendLastName, friendFirstName)

		return "redirect:/friends/list.action?lastName=$lastName&firstName=$firstName"
	}
}
