package com.burtbeckwith.gae.guestbook.domain

import javax.jdo.annotations.Embedded
import javax.jdo.annotations.EmbeddedOnly
import javax.jdo.annotations.IdGeneratorStrategy
import javax.jdo.annotations.IdentityType
import javax.jdo.annotations.PersistenceCapable
import javax.jdo.annotations.Persistent
import javax.jdo.annotations.PrimaryKey

@PersistenceCapable(identityType = IdentityType.APPLICATION)
class AddressBookEntry {

	@PrimaryKey
	@Persistent(valueStrategy=IdGeneratorStrategy.IDENTITY)
	private Long id

	@Persistent
	@Embedded
	PersonalInfo personalInfo

	@Persistent
	@Embedded
	AddressInfo addressInfo

	@Persistent
	@Embedded
	ContactInfo contactInfo

	Long getId() {
		return id
	}
}

@PersistenceCapable
@EmbeddedOnly
class PersonalInfo {

	String lastName
	String firstName

	PersonalInfo(String firstName, String lastName) {
		this.lastName = lastName
		this.firstName = firstName
	}
}

@PersistenceCapable
@EmbeddedOnly
class AddressInfo {

	String city
	String state

	AddressInfo(String city, String state) {
		this.city = city
		this.state = state
	}
}

@PersistenceCapable
@EmbeddedOnly
class ContactInfo {

	String phoneNumber

	ContactInfo(String phoneNumber) {
		this.phoneNumber = phoneNumber
	}
}
