package com.burtbeckwith.gae.guestbook.domain

import javax.jdo.annotations.IdentityType
import javax.jdo.annotations.PersistenceCapable
import javax.jdo.annotations.Persistent
import javax.jdo.annotations.PrimaryKey

import com.google.appengine.api.datastore.KeyFactory

@PersistenceCapable(identityType = IdentityType.APPLICATION)
class Friend {

	@PrimaryKey
	private String key

	@Persistent
	private String lastName

	@Persistent
	private String firstName

	@Persistent(defaultFetchGroup = 'true')
	Collection<String> friendKeys = []

	Friend(String lastName, String firstName) {
		this.key = lastName + ', ' + firstName
		this.lastName = lastName
		this.firstName = firstName
	}

	String getKey() {
		return key
	}

	String getId() {
		return key
	}

	String getLastName() {
		return lastName
	}

	String getFirstName() {
		return firstName
	}

	List<String> getFriends() {
		return friendKeys.collect { friendKey -> KeyFactory.stringToKey(friendKey).name }
	}
}
