package com.burtbeckwith.gae.guestbook.domain

import javax.jdo.PersistenceManager
import javax.jdo.Query
import javax.jdo.annotations.IdGeneratorStrategy
import javax.jdo.annotations.IdentityType
import javax.jdo.annotations.PersistenceCapable
import javax.jdo.annotations.Persistent
import javax.jdo.annotations.PrimaryKey

@PersistenceCapable(identityType = IdentityType.APPLICATION)
class GuestbookEntry {

	@PrimaryKey
	@Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
	private Long id

	@Persistent
	private String who

	@Persistent
	private Date when

	@Persistent
	private String message

	GuestbookEntry(String who, String message) {
		this.message = message
		this.who = who
		this.when = new Date()
	}

	String getWho() {
		return who
	}

	Date getWhen() {
		return when
	}

	String getMessage() {
		return message
	}

	static void insert(String who, String message) {
		new GuestbookEntry(who, message).save()
	}

	static List<GuestbookEntry> getEntries() {
		return findAll(orderBy: 'when DESC')
	}
}
