package com.burtbeckwith.gae.guestbook.domain

import javax.jdo.annotations.IdentityType
import javax.jdo.annotations.PersistenceCapable
import javax.jdo.annotations.Persistent
import javax.jdo.annotations.PrimaryKey

import com.google.appengine.api.datastore.KeyFactory

@PersistenceCapable(identityType=IdentityType.APPLICATION, detachable="true")
class NamedCounter {

	@PrimaryKey
	private String name

	@Persistent
	private int count

	NamedCounter(String name) {
		// You have to supply the keyName here, event though this
		// field later becomes the serialized Key.
		this.name = name
	}

	int getCount() {
		return this.count
	}

	void add(int delta) {
		this.count += delta
	}

	String getId() {
		return this.name
	}

	String getName() {
		// Once submitted, the @PrimaryKey will be turned into
		// a serialized Key instance, which is why we need to
		// do this stuff.
		return KeyFactory.stringToKey(name).name
	}
}
