package com.burtbeckwith.gae.guestbook.service

import javax.jdo.PersistenceManager

import com.burtbeckwith.gae.guestbook.domain.NamedCounter

import com.google.appengine.api.datastore.Key
import com.google.appengine.api.datastore.KeyFactory

class NamedCounterService {

	NamedCounter getByName(String name) {
		return NamedCounter.get(generateKey(name)) ?: new NamedCounter(name)
	}

	int addAndGet(String name, int delta) {
		NamedCounter.withTransaction true, {
			NamedCounter counter = NamedCounter.get(generateKey(name)) ?: new NamedCounter(name)
			counter.add(delta)
			if (!counter.isJdoPersistent()) {
				counter.save()
			}
			return counter.count
		}
	}

	void reset(String name) {
		NamedCounter.delete(generateKey(name))
	}

	private String generateKey(String name) {
		Key key = KeyFactory.createKey(NamedCounter.simpleName, name)
		return KeyFactory.keyToString(key)
	}
}
