package com.burtbeckwith.gae.framework;

import java.util.Date;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

/**
 * {@link ServletContextListener} that triggers MetaClass method additions at app startup.
 *
 * @author <a href='mailto:burt@burtbeckwith.com'>Burt Beckwith</a>
 */
public class ContextListener implements ServletContextListener {

	/**
	 * {@inheritDoc}
	 * @see javax.servlet.ServletContextListener#contextInitialized(javax.servlet.ServletContextEvent)
	 */
	public void contextInitialized(final ServletContextEvent event) {
		System.out.println("app startup at " + new Date());
		DynamicUtils.configure(event.getServletContext());
	}

	/**
	 * {@inheritDoc}
	 * @see javax.servlet.ServletContextListener#contextDestroyed(javax.servlet.ServletContextEvent)
	 */
	public void contextDestroyed(final ServletContextEvent event) {
		System.out.println("app shutdown at " + new Date());
	}
}
