package com.burtbeckwith.gae.framework;

import java.io.IOException;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Filter to expose the Request and Response for each request.
 *
 * @author <a href='mailto:burt@burtbeckwith.com'>Burt Beckwith</a>
 */
public class HolderFilter extends AbstractFilter {

	@Override
	protected void doFilterHttp(final HttpServletRequest request, final HttpServletResponse response,
			final FilterChain chain) throws IOException, ServletException {

		RequestHolder.set(new RequestAttributes(request, response));
		try {
			chain.doFilter(request, response);
		}
		finally {
			RequestHolder.reset();
		}
	}
}
