package com.burtbeckwith.gae.framework;

import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Holder for the current request, response, and 'params' object.
 *
 * @author <a href='mailto:burt@burtbeckwith.com'>Burt Beckwith</a>
 */
public class RequestAttributes {

	private ParameterMap _params;
	private final HttpServletRequest _request;
	private final HttpServletResponse _response;

	public RequestAttributes(final HttpServletRequest request, final HttpServletResponse response) {
		_request = request;
		_response = response;
	}

	@SuppressWarnings("unchecked")
	public Map getParameterMap() {
		if (_params == null) {
			_params = new ParameterMap(_request);
		}
		return _params;
	}

	public HttpServletRequest getRequest() {
		return _request;
	}

	public HttpServletResponse getResponse() {
		return _response;
	}
}
