package com.burtbeckwith.gae.framework;

/**
* Uses a {@link ThreadLocal} to store the current request and response.
*
* @author <a href='mailto:burt@burtbeckwith.com'>Burt Beckwith</a>
*/
public final class RequestHolder {

	private static final ThreadLocal<RequestAttributes> HOLDER = new ThreadLocal<RequestAttributes>();

	private RequestHolder() {
		// static only
	}

	/*package*/ static void set(RequestAttributes attributes) {
		HOLDER.set(attributes);
	}

	/*package*/ static void reset() {
		HOLDER.set(null);
	}

	public static RequestAttributes get() {
		return HOLDER.get();
	}
}
