<%@page isELIgnored="false"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  <title>Addressbook Demo</title>	
</head>

<body>
<h2>Entries</h2>

<form action='/addressbook/list.action' method='get'>
	<p>
		<p>Select entries with 
		Last name: <input type='text' name='lastNameSelected' value="${lastNameSelected}">
		and/or State: <input type='text' name="stateSelected" value="${stateSelected}">
		<input type='submit' value='Search'>
	</p>
</form>

<c:choose>
	<c:when test="${empty entries}">
	There are no entries.
	</c:when>
	<c:otherwise>
		<c:forEach var='entry' items='${entries}'>
		<div>
			<div>${entry.personalInfo.firstName} ${entry.personalInfo.lastName}</div>
			<div>${entry.addressInfo.city}, ${entry.addressInfo.state}</div>
			<div>${entry.contactInfo.phoneNumber}</div>
		</div>
		<br />
		</c:forEach>
	</c:otherwise>
</c:choose>

<c:choose>
	<c:when test="${lastEntry != null}">
	<a href="/addressbook/list.action?page=${lastEntry.id}">Next page by key offset</a>
	<a href="/addressbook/list.action?startIndex=${indexOffset + 3}">Next page by index offset</a>
	</c:when>
	<c:otherwise>
	No more pages of entries.
	</c:otherwise>
</c:choose>

<h2>New entry</h2>
<form action='/addressbook/addEntry.action' method='post'>
	<p>First name: <input type='text' name='firstName'> Last name: <input type='text' name='lastName'></p>
	<p>City: <input type='text' name='city'>, State: <input type='text' name='state'></p>
	<p>Phone number: <input type='text' name='phoneNumber'></p>
	<p><input type='submit' value='Submit'></p>
</form>
<br>

</body>
</html>
